{{ Atari Controller for VGA header Object (See Documentation)
  Version:  1.0
  Date: 19 Apr 2007
  Author: Jeff Ledger
  Support:  Propeller forum http://forums.parallax.com
  Revision history:  Version 1.0 Supports Atari Joystick on VGA header
}} 
'
' This is the test program for the Atari Joystick Interface for the
' VGA header.   It uses the built-in 240ohm resistors for debouce.
' 
' This has been tested with the Protoboard, and should work with
' the Demoboard as well.
' 
' Refer to "atarijoy_vga_schematic.JPG" for DB15<->DB9 interface
' construction.
'
'
'
Con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  JOY_RIGHT  = %00000001
  JOY_LEFT   = %00000010
  JOY_DOWN   = %00000100
  JOY_UP     = %00001000
  JOY_FIRE   = %00010000
  
OBJ
    tv       : "TV_Text"
    joystick : "joystick_drv_001.spin"
    
VAR
 long button
   
PUB Main

  tv.start(12)

  tv.str(string("Atari Joystick Demo",13))  

  repeat
     If (joystick.button(JOY_FIRE))
        tv.str(string("FIRE!",13))

     If (joystick.button(JOY_RIGHT))
        tv.str(string("RIGHT",13))   

     If (joystick.button(JOY_LEFT))
        tv.str(string("LEFT",13))   

     If (joystick.button(JOY_DOWN))
        tv.str(string("DOWN",13))   

     If (joystick.button(JOY_UP))
        tv.str(string("UP",13))   

   
      